<?php
	

// ---------------------------------------------------------------------------
//
// PIVOT - LICENSE:
//
// This file is part of Pivot. Pivot and all its parts are licensed under 
// the GPL version 2. see: http://www.pivotlog.net/help/help_about_gpl.php
// for more information.
//
// ---------------------------------------------------------------------------


	
//save the settings file each time the script ends. (linux only..)
//register_shutdown_function('SaveSettings');
	
//just load up the settings.	
function GetSettings() {
	global $Cfg, $Weblogs, $pivot_path;

	// get the config file
	$fh = file($pivot_path.'pv_cfg_settings.php'); 

	foreach ($fh as $fh_this) {
		@list($name, $val) = split("!", $fh_this);
		$Cfg[$name] = rtrim(ltrim($val));
	}	
	GetUserInfo();
	ExpandSessions();	
	
	@$Cfg['ping_urls']=str_replace("|", "\n", $Cfg['ping_urls']); 
	@$Cfg['default_introduction']=str_replace("|", "\n", $Cfg['default_introduction']); 

	// also get the weblogs file
	$Weblogs = load_serialize($pivot_path."pv_cfg_weblogs.php");
	unset($Weblogs['']);

}	


//save the settings.
function SaveSettings() {
	global $Cfg;

	PutUserInfo();
	ContractSessions();

	debug('savesettings');
	
	// a hack for ping_urls.
	if (isset($Cfg['ping_urls'])) { 
		$Cfg['ping_urls'] = str_replace("\n", "|", $Cfg['ping_urls']); 
		$Cfg['ping_urls'] = str_replace("\r", "", $Cfg['ping_urls']); 
	}

	// a hack for default_intro
	if (isset($Cfg['default_introduction'])) {
		$Cfg['default_introduction'] = str_replace("\n", "|", $Cfg['default_introduction']);
		$Cfg['default_introduction'] = str_replace("\r", "", $Cfg['default_introduction']); 
	}

	//unset($Cfg['tempsessions']);
	$fh = fopen('pv_cfg_settings.php', 'w'); 
	fwrite($fh, "<?php\n");

	ksort($Cfg);

	foreach($Cfg As $key => $value) {
		if($key && ($value != '') && ($key!='tempsessions')) {
			fwrite($fh, "$key!$value\n");
		} 
	}
	fwrite($fh, "?".">\n");
	fclose($fh);	
}
	

function ExpandSessions() {
	global $Cfg;
	if (isset($Cfg['sessions'])) {
		foreach(split('\|-\|' , $Cfg['sessions']) as $val){
			$vars = split('\|', $val);
			for($i=1; $i <= 4; $i++) {
				$Cfg['tempsessions'][$vars[0]][] = $vars[$i];
			}	
		}	
	}	
}


function ContractSessions() {
	global $Cfg;
	while (list($session,$meh) = @each($Cfg['tempsessions'])) {
		if(($Cfg['tempsessions'][$session][2] - time()) >= 0) {
			$tmp[] = $session.'|'.join('|', $Cfg['tempsessions'][$session]);
		}	
	}
	if(is_array($tmp)) {
		$Cfg['sessions'] = join('|-|', $tmp);
	}
}	
		

// gets the user info for everyone.
function GetUserInfo() {
	global $Cfg, $Users;
	foreach(split('\|', trim($Cfg['users'])) as $inc => $user){
		foreach(split('\|-\|' , $Cfg['user-' . $user]) as $var => $val){
			list($Nvar, $Nval) = split('\|', $val);
			$Users[$user][$Nvar] = $Nval;			
		}
	}
}


function PutUserInfo() {
	global $Cfg, $Users;
	foreach($Users as $uname => $vals){
		$ahoy = array();
		foreach($vals as $varname => $value){
			$ahoy[] = "$varname|$value";	
		}
		// bob notes: changed to >= 3 (otherwise it won't store username 'bob')
		// i feel neglected now :-.
		if(strlen($uname) >= 3) {
			$Cfg["user-$uname"] = join('|-|', $ahoy);
		}			
	}	
}


function GetUserFields() {
	global $Cfg;
	$ufields['heading']['disp'] = lang('adminbar', 'userfields');
	$ufields['heading']['size'] = 2;
	$ufields['heading']['type'] = 8;
	foreach(split('\|', trim($Cfg['userfields'])) as $inc => $field){
		foreach(split('\|-\|' , $Cfg['uf-' . $field]) as $var => $val){
			list($Nvar, $Nval) = split('\|', $val);
			$ufields[$field][$Nvar] = $Nval;			
		}
	}
		
	return $ufields;		
}
	

function PutUserFields($data) {
	//rebuilds all the info from user fields, which should have been taken from GetUserFields
	global $Cfg;
	foreach($data as $key => $arr) {
		$turger[] = $key;
		foreach($data[$key] as $item => $val){
			$pressure[] = "$item|$val";	
		}
		$Cfg['uf-'.$key] = join("|-|", $pressure);
		unset($pressure);
	}
	
	$Cfg['userfields'] = join("|", $turger);		
}


function ExpandBlogs(){
	global $Cfg;
	//expands just the list of weblogs.
	foreach(split('\|-\|', trim($Cfg['weblogs'])) as $inc => $still){
		foreach(split('\|' , $still) as $int => $ext){
			$lWeblogs[] = "$ext";
		}
		
	}
//	print_r($lWeblogs);
	return $lWeblogs;
}
	

function ContractBlogs() {
	
}



function CheckInput($input, $minlen=2, $maxlen=12) {
	//if it returns nothing, it passes.
	//0 = fail by input [not alphanumberic or _]
	//1 - fail by length [too short]
	//2 - fail by length [too long]
	if(ereg("^[a-zA-Z0-9\_\s]+$", $input)){
		if(strlen($input) < $minlen){
			return 	1;
		}
		if(strlen($input) > $maxlen){
			return 2;	
		}
	}else{
		return 0;
	}	
}
	



// give this function a string and it will tell you
// whether it is a mail adress or not.. magically!!
function isemail($email) {
	return(preg_match("/^[-_.[:alnum:]]+@((([[:alnum:]]|[[:alnum:]][[:alnum:]-]*[[:alnum:]])\.)+(ad|ae|aero|af|ag|ai|al|am|an|ao|aq|ar|arpa|as|at|au|aw|az|ba|bb|bd|be|bf|bg|bh|bi|biz|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|com|coop|cr|cs|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|in|info|int|io|iq|ir|is|it|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|mg|mh|mil|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|museum|mv|mw|mx|my|mz|na|name|nc|ne|net|nf|ng|ni|nl|no|np|nr|nt|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|pro|ps|pt|pw|py|qa|re|ro|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)|(([0-9][0-9]?|[0-1][0-9][0-9]|[2][0-4][0-9]|[2][5][0-5])\.){3}([0-9][0-9]?|[0-1][0-9][0-9]|[2][0-4][0-9]|[2][5][0-5]))$/i", $email));

}


// give this function a string and it will tell you
// whether it is a url or not.. magically!!
function isurl($url) {

 return (preg_match("/((ftp|https?):\/\/)?([a-z0-9](?:[-a-z0-9]*[a-z0-9])?\.)+(com\b|edu\b|biz\b|org\b|gov\b|in(?:t|fo)\b|mil\b|net\b|name\b|museum\b|coop\b|aero\b|[a-z][a-z]\b|[0-9]{1,3})/i",$url));

}


function short($input){
	return ltrim(rtrim(strtolower($input)));
}

			
function libchange_user($admin=0, $erred=0, $newdata='') {
	global $Pivot_Vars, $Users, $ThisUser, $Cfg;


	if($erred==0){
		$userfields = get_userfields($admin);
	}else{
		$userfields = $newdata;	
	}
	if($admin==1){
		$theuser = $Pivot_Vars['edituser'];	
		$ThisUser = $Users[$theuser];
	}else{
		$theuser = $Pivot_Vars['user'];	
	}

	MinLevel($Users[$theuser]['userlevel']);


	StartForm('save_user', $admin);
	StartTable();
	$userfields[0][4] = $theuser;
	$userfields[0][6] = 'disabled';
	if($admin==1){


		// make sure superadmin doesn't demote himself.
		if($Users[$theuser]['userlevel'] > 3){
			$userfields[5][4] = array('0' => lang('userlevels',4-$Users[$theuser]['userlevel']), '1' => $Users[$theuser]['userlevel']);	
		} 
	}

	if($erred==0){
		$ufields = GetUserFields();
		foreach($ufields As $keyname => $arrg) {
			$type = 0;
			if(is_int($ufields[$keyname]['maxlen'])){
				$maxl =  'maxlength=\"'.$ufields[$keyname]['maxlen'].'\"';	
			}else{
				$maxl = '';	
			}
			array_push($userfields, array($keyname, $ufields[$keyname]['disp'], '', $ufields[$keyname]['type'], $Users[$theuser][$keyname], $ufields[$keyname]['size'], $maxl));	
		}
	}	


	// checkboxes for allowed categories
	if($Users[$Pivot_Vars['user']]['userlevel'] > 2){

		$userfields[] = array('heading', "Allowed Categories", '', 8, '', 2);

		foreach(explode("|", $Cfg['cats']) as $cat){
			if ($cat != "" ) {

				$label = sprintf('&nbsp;&nbsp;&nbsp;'.$cat);
				$allowed_users = explode("|", $Cfg['cat-'.$cat]);
				if (in_array($theuser, $allowed_users)) {
					$userfields[] = array('allowed['.$cat.']', $label, '', 2, 1, '', '');
				} else {
					$userfields[] = array('allowed['.$cat.']', $label, '', 2, 0, '', '');
				}
			}
		}
		$userfields[(count($userfields)-1)][2]  = 'This user is allowed to post entries in the selected categories'; 

	}




	DisplaySettings($userfields, 'ThisUser');	
	GenSetting('username', '', '', 7, $theuser, '', '');
	if($Pivot_Vars['func']=='admin' && ($Pivot_Vars['do']=='edituser' || $Pivot_Vars['do']=='save_user') && $Users[$Pivot_Vars['user']]['userlevel'] > $Users[$theuser]['userlevel']){
		GenSetting('heading', 'Delete', '', 8);
		GenSetting('delete_user', 'Delete User', 'You can delete this user if you would like. All of their posts will remain, but they will no longer be able to login', 3, 'yn');	
	}
	EndForm(lang('userinfo','edituser_button'), 1);						
}



function libsave_change_user($admin=0) {
	global $Pivot_Vars, $Users, $Cfg, $HTTP_POST_VARS;
	$userfields = get_userfields($admin);
	$ufields = GetUserFields();

	// add userfield for wysi
	array_push($userfields, array('wysiwyg', 'Use Wysiwyg editor?', '', '3', 'yn'));

	

	if($admin==1){
		$theuser = $Pivot_Vars['username'];	
	}else{
		$theuser = $Pivot_Vars['user'];	
	}
	if(($Pivot_Vars['delete_user']==1) && ($Users[$Pivot_Vars['user']]['userlevel'] >= 3)){
		if($Pivot_Vars['confirmed'] == 1){
			//delete him from the config file, nothing else.
			$tmp_arr = explode("|", $Cfg['users']);
			foreach($tmp_arr as $candidate){
				if($candidate != $Pivot_Vars['username']){
					$tmp_arr2[] = $candidate;	
				}
			}
			$Cfg['users'] = implode( "|", $tmp_arr2);
			unset($Users[$Pivot_Vars['username']]);
			unset($Cfg['user-'.$Pivot_Vars['username']]);
			see_users();
		}else{
			$vars = array('username', $Pivot_Vars['username'], 'delete_user', 1);
			ConfirmPage(lang('ufield_main','del_title'), $vars, sprintf("You're about to remove access for %s, you sure you want to do this?", $Pivot_Vars['username']));
		}
	}else{
		foreach($ufields As $keyname => $intarr){
			array_push($userfields, array($keyname, $ufields[$keyname]['disp'], '', $ufields[$keyname]['type'], $Users[$theuser][$keyname], $ufields[$keyname]['size'], $maxl));	
			if($ufields[$keyname]['filter'] != '' && (strlen($Pivot_Vars[$keyname]) > 0)){
				$tfunk = 'is' . $ufields[$keyname]['filter'];
				if(!($tfunk($Pivot_Vars[$keyname]))){
					$userfields[count($userfields)-1][2] = 'hey, that input doesn\'t go along with the filter in place';
					$Piverr++;
				}
			}	
		}
		$arraycount = Count($userfields);
	
		if(strlen($Pivot_Vars['pass1']) + strlen($Pivot_Vars['pass2']) >= 1){
			if((short($Pivot_Vars['pass1'])) != (short($Pivot_Vars['pass2']))) {
				$userfields[2][2] = lang('userinfo','pass_dont_match');
				$Piverr++;		
			}
			if( strlen($Pivot_Vars['pass1']) < 4 ){
				$userfields[1][2] = lang('userinfo','pass_too_short');
				$Piverr++;		
			}					
		}	
		if($Piverr==0){
			
			// make sure the superadmin doesn't demote himsef/herself..
			if ($Users[$theuser]['userlevel']==4){
				$Pivot_Vars['userlevel']=4;
			}

			// get confirmation if user gets admin rights
			if(($Pivot_Vars['userlevel']==3) && ($Users[$theuser]['userlevel']<3) && ($Pivot_Vars['confirmed'] != 1)){
					$vars = array();
					$arraycount = Count($userfields);
					for($i = 0; $i < $arraycount; $i++){
						array_push($vars, $userfields[$i][0], $Pivot_Vars[$userfields[$i][0]]);	
					}
				ConfirmPage(lang('userinfo','c_admin_title'), $vars, sprintf(lang('userinfo','c_admin_message'), $theuser));
			}else{
				//it's all good.
				if(strlen($Pivot_Vars['pass1']) >= 6){
					$Users[$theuser]['pass'] = md5($Pivot_Vars['pass1']);
					if($_COOKIE['mode'] == 'stayloggedin' && $Pivot_Vars['user'] == $theuser){
						setcookie('pass', md5($Pivot_Vars['pass1']), time()+$Cfg['cookie_length']);
					}
					//change the session key too..
					$Cfg['tempsessions'][$Pivot_Vars['session']][1] = md5($Pivot_Vars['pass1']);				
				}
				for($i = 0; $i < $arraycount; $i++){
					if(($userfields[$i][0] != 'heading') && ($userfields[$i][0] != 'pass1') && ($userfields[$i][0] != 'pass2')) {
						$Users[$theuser][$userfields[$i][0]] = $Pivot_Vars[$userfields[$i][0]];
					}
				}		
				
				// set the categories..
			
				if($Users[$Pivot_Vars['user']]['userlevel'] > 2){
					foreach (explode("|", $Cfg['cats']) as $category) {
							
						$allowed_users = explode("|", $Cfg['cat-'.$category]);

						if (isset($Pivot_Vars['allowed'][$category])) {
							// add the user..
							if (!in_array($theuser, $allowed_users)) {
								$allowed_users[] = $theuser;
							}

						} else {
							// remove the user..
							if (in_array($theuser, $allowed_users)) {
								foreach ($allowed_users as $key => $user) {
									if ($user == $theuser) { unset ($allowed_users[$key]); }
								}
							}
						}

						$Cfg['cat-'.$category] = implode("|", $allowed_users);

					}
				}

				SaveSettings();
				//so we can reload the languages and such
				if($admin==1){
					Header('Location: index.php?session='.$Pivot_Vars['session'].'&menu=admin&func=admin&do=seeusers');
					die();
				}else{
					Header('Location: index.php?session='.$Pivot_Vars['session'].'&menu=userinfo&func=u_settings');	
					die();
				}
			}
		}else{
			//reshow the spage
			$Pivot_Vars['edituser'] = $Pivot_Vars['username'];
			//regroup the old settings.
			for($i=0; $i < $arraycount; $i++){
				if($userfields[$i][3]==0){
					$userfields[$i][4] = $Pivot_Vars[$userfields[$i][0]];
				}elseif($userfields[$i][3]==3){
					$userfields[$i][6] = $Pivot_Vars[$userfields[$i][0]];
				}	
			}
		}
		if($Users[$theuser]['userlevel'] > 3){
			//ARGHH!!!!!!
			$unf[0] = $userfields[4][6];
			$unf[1] = 'disabled';
			unset($userfields[4][6]);
			$userfields[4][6] = $unf;
		}
		if($admin==1){
			change_user(1, $userfields);
		}else{
			u_settings_screen(1, $userfields);	
		}
	}
	PutUserInfo();	
}



function show_image_list($fileArray,$thumbArray) {
	global $Cfg, $Pivot_Vars, $base_url;

	printf('<script>function pop(a){window.open("modules/module_image.php?image="+a,"%s","toolbar=no,resizable=yes,scrollbars=yes,width=520,height=550");}</script>',$file['name']);

	$myurl =sprintf("index.php?session=%s&menu=files&doaction=1", $Pivot_Vars['session']);
	printf("<form name='form1' method='post' action='%s'>", $myurl);

	echo '<table cellspacing="0" class="tabular_border">';

	printf('<tr class="tabular_header"><td>&nbsp;</td><td width="200">%s</td><td>%s</td><td width="100">%s</td><td>%s</td><td>%s</td></tr>',lang('upload','filename'),lang('upload','thumbnail'),lang('upload','date'),lang('upload','filesize'),lang('upload','dimensions'));
	
	
	foreach($fileArray as $key => $file) {
		
		$fullentry = urlencode(fixpath(sprintf('%s../%s%s',$base_url ,$Cfg['upload_path'],$file['name'])));
		$thumb = check_for_common($file['name']);

		if (!isset($linecount)) {
			$linecount=1;
		} else {
			$linecount++;
		}

		if (($linecount % 2)==0) { 
			$bg_color="tabular_line_even";
		} else {
			$bg_color="tabular_line_odd"; 
		}

		$url=sprintf($base_url."/includes/photo.php?img=%s&w=%s&h=%s&t=%s",$fullentry, $file['width'], $file['height'], $file['name']); 
		$view_html = sprintf("<a href='%s' onclick=\"window.open('%s', 'imagewindow', 'width=%s, height=%s, directories=no, location=no, menubar=no, scrollbars=no, status=no, toolbar=no, resizable=no');return false\" target='_self' title='%s'>", urldecode($fullentry), $url, $file['width'], $file['height'], $file['name'] );

		printf('<tr class="%s">',$bg_color);
		printf("<td><input type='checkbox' name='check[%s]'></td>",$file['name']);
		printf('<td>%s%s</a></td>',$view_html, trimtext(strtolower(urldecode($file['name'])), 40, TRUE));
		
		if($thumb != $file['name']) {
			printf('<td><a href=javascript:pop("%s");>' . lang('upload', 'edit') . '</a></td>',$file['name']);
		} else {
			printf('<td><a href=javascript:pop("%s");>' . lang('upload', 'create') . '</a></td>',$file['name']);
		}

		printf('<td>%s</td><td>%d KB</td><td>%d x %d</td></tr>',$file['date'],$file['size'],$file['width'],$file['height']);
	}

	echo '<tr class="tabular_nav"><td colspan="7"><img src="pics/arrow_ltr.gif" width="29" height="14" border="0" alt="">';
	echo '<a href="#" onclick=\'setCheckboxes("form1", true); return false;\'>'. lang('forms', 'c_all') .'</a> / ';
	echo '<a href="#" onclick=\'setCheckboxes("form1", false); return false;\'>'. lang('forms', 'c_none') .'</a>';
	echo '&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;'. lang('forms', 'with_checked_files');
	echo '<select name="action" class="input"><option value="" selected>'. lang('forms', 'choose') .'</option><option value="delete">'. lang('forms', 'delete') .'</option></select>';
	echo '&nbsp;&nbsp;<input type="submit" value="'. lang('go') .'" class="button">';
	printf("</table></form>");
	
	GenSetting('',lang('upload','thisfile'),'',8,'',6);
	StartForm('file_upload', 0, 'enctype="multipart/form-data"');
	printf('<input name="%s" type="file"  class="input"><br />',$Cfg['upload_file_name']);
	printf('<input type="submit" value="%s" class="button"></form>',lang('go'));	

	PageFooter();
} 


function show_image_preview($fileArray,$thumbArray) 	{
	global $Cfg, $base_url, $Pivot_Vars;
	
	printf('<script>function pop(a){window.open("modules/module_image.php?image="+a,"","toolbar=no,resizable=yes,scrollbars=yes,width=520,height=550");}</script>');

	$myurl =sprintf("index.php?session=%s&menu=files&doaction=1", $Pivot_Vars['session']);
	printf("<form name='form1' method='post' action='%s'>", $myurl);

	StartForm('file_delete',0);

	echo '<div style="margin:0px; padding:0px;">';

	foreach($fileArray as $file) {

		$ext=getextension(strtolower($file['name']));
		if ( ($ext!="gif") && ($ext!="jpg") && ($ext!="jpeg") && ($ext!="png") && ($ext!="swf") ) {
			continue;
		}		

		$thumb = check_for_common($file['name']);
		$fullentry = urlencode(fixpath(sprintf('%s../%s%s',$base_url ,$Cfg['upload_path'],$file['name'])));
		$thumbententry = fixpath(sprintf('%s../%s%s',$base_url ,$Cfg['upload_path'],$thumb));
		list($thumbwidth, $thumbheight) = getimagesize(urldecode("../".$Cfg['upload_path'].$thumb));
		
		// Calculate rescaling factor for
		// showing thumbnail in table/div

		// for wide thumbnails, take two 'cells', otherwise one..
		if ( ($thumbwidth / $thumbheight) < 2 ) {
			$mw	= 130;
		}	else {
			$mw = 268; // * 2 , + 8
		}

		$mh		= 80;
		$scalew = $thumbwidth / $mw;
		$scaleh = $thumbheight / $mh;
		$factor = max($scalew,$scaleh);
		$dw		= $thumbwidth / $factor;
		$dh		= $thumbheight / $factor;
		

		// if filesize is bigger than 9999 KB
		// then filesize comment is changed, this
		// is just for not fucking up the tables/divs
		if(strlen($file['size']) > 4) {
			// see!? no more than 4 chars,
			// please change size of file
			$fs = 'BIGASS';
		} else {
			// show actual filesize + string KB
			$fs = $file['size'].'KB';
		}

		echo '<div style="float:left; border:1px solid #2D5A5A; margin:3px;">';
		printf('<table cellpadding="0" cellspacing="0" width="%d" border="0">',$mw);
		
		printf('<tr><td align="center" valign="middle" bgcolor="#BBBBBB" height="%d" colspan="2">',$mh);

		// make the 'view' link
		$url=sprintf($base_url."/includes/photo.php?img=%s&w=%s&h=%s&t=%s",$fullentry, $file['width'], $file['height'], $file['name']); 

		$view_html = sprintf("<a href='%s' onclick=\"window.open('%s', 'imagewindow', 'width=%s, height=%s, directories=no, location=no, menubar=no, scrollbars=no, status=no, toolbar=no, resizable=no');return false\" target='_self' title='%s (%s)'>", urldecode($fullentry), $url, $file['width'], $file['height'], $file['name'], $fs );

		if($thumb != $file['name']) {
			printf('%s<img src="%s" width="%d" height="%d" border="0" alt="%s"></a>',$view_html,$thumbententry,$dw,$dh,$file['name']);
		} else {
			printf('%s<small>%s <br /><br />(No Thumbnail)</small></a>',$view_html, wordwrap(urldecode($file['name']),14, ' ',1));
		}
		echo '</td></tr><tr><td bgcolor="#B6CCCC">';
		printf("<input type='checkbox' name='check[%s]'></td>",$file['name']);


		printf('<td align="center" bgcolor="#B6CCCC" height="17">%sview</a>&nbsp;/&nbsp;', $view_html);

		if($thumb != $file['name']) {
			printf('<a href=javascript:pop("%s");>edit</a></td>',$file['name']);
		} else {
			printf('<a href=javascript:pop("%s");>create</a></td>',$file['name']);
		}
		
		echo '</tr></table></div>';

	}

	echo '</div><br clear="all">';

	printf("<table cellpadding=2><tr><td bgcolor='#B6CCCC'>");
	echo '<a href="#" onclick=\'setCheckboxes("form1", true); return false;\'>'. lang('forms', 'c_all') .'</a> / ';
	echo '<a href="#" onclick=\'setCheckboxes("form1", false); return false;\'>'. lang('forms', 'c_none') .'</a>';
	echo '&nbsp;&nbsp;&nbsp;-&nbsp;&nbsp;'. lang('forms', 'with_checked_files');
	echo '<select name="action" class="input"><option value="" selected>'. lang('forms', 'choose') .'</option><option value="delete">'. lang('forms', 'delete') .'</option></select>';
	echo '&nbsp;&nbsp;<input type="submit" value="'. lang('go') .'" class="button">';
	printf("</td></tr></table></form>");

	flush();

	GenSetting('',lang('upload','thisfile'),'',8,'',6);
	StartForm('file_upload', 0, 'enctype="multipart/form-data"');
	printf('<input name="%s" type="file"  class="input"><br />',$Cfg['upload_file_name']);
	printf('<input type="submit" value="%s" class="button"></form>',lang('go'));	

	PageFooter();
}



// Open images directory and splitting the
// thumbnails from the original in 2 arrays.
function getFileList() {
	global $Cfg, $fileArray, $thumbArray;

	$fileArray = Array();
	$thumbArray = Array();

	$uploadPath = sprintf('../%s',$Cfg['upload_path']);

	$d = opendir($uploadPath) or die(lang('error','path_open'));

	while(false !== ($f = readdir($d))) {
		$files[] = $f;
	}

	sort($files); 

	foreach ($files as $f) {		
			if(is_file($uploadPath.$f)) {
			$fileSize = round(filesize($uploadPath.$f)/1024);
			$fileDate = filemtime($uploadPath.$f);
			$fileDate = format_date(date('Y-m-d-H-i', $fileDate),'%day%-%month%-%ye% %hour24%:%minute%');
			if(!preg_match('/(\.thumb\.)/',$f)) {
				$tmp = getImageSize($uploadPath.$f);
				$tmp = Array('name'=>urlencode($f), 'width'=>$tmp[0], 'height'=>$tmp[1], 'date'=>$fileDate, 'size'=>$fileSize);
				array_push($fileArray,$tmp);
			} else {
				$tmp = getImageSize($uploadPath.$f);
				$tmp = Array('name'=>$f,'width'=>$tmp[0],'height'=>$tmp[1],'date'=>$fileDate,'size'=>$fileSize);
				array_push($thumbArray,$tmp);
			}
		}
	}
	closedir($d);
	
	usort($fileArray, 'filearray_sort');	
	
	return array($fileArray, $thumbArray);

	
}


function filearray_sort($a, $b) {
	if (strtolower($a['name']) == strtolower($b['name'])) return 0;
	return (strtolower($a['name']) < strtolower($b['name'])) ? -1 : 1;
}



function check_for_common($str) 
{
	global $thumbArray;

	// first we split up the extension from filename
	// with a simple regexp... god i love regexp :-)
	preg_match('/^(.*)\.(.*)$/i',$str,$match);
	$compare = strtolower($match[1]);

	foreach($thumbArray as $val) {

		$thumb = strtolower(substr($val['name'],0,strlen($compare)));

		if($compare == $thumb) {
			// MATCH!!!
			$str = $val['name'];
		}
	}
	return $str;
}



function getextension($file) {
	$pos=strrpos($file, ".");
	if (is_string ($pos) && !$pos) {
	    // not found...
		return "";
	} else {
		$ext=substr($file, $pos+1);
		//echo "ext=$ext<br />\n";
		return $ext;
	}
}

// This will format $date, according to the passed $format
function format_date( $date="", $format="") {
	global $Cfg, $current_date, $db;

	if ($format=="") { $format="%day% %monname% '%ye%"; }

	// if format does nof contain '%' just return to save some processing time
	if (strpos($format, "%")=== FALSE) {
		return $format;
	}
	
	if ($date=="") {$date= date("Y-m-d-H-i", get_current_date()); }
	list($yr,$mo,$da,$ho,$mi)=split("-",$date);

	$mktime = mktime(1,1,1,$mo,$da,$yr);

	$ho12 = ($ho>11) ? $ho - 12 : $ho;
	$ampm= ($ho12==$ho) ? "am" : "pm";
	if ($ho12==0) { $ho12=12; }
	
	$format=str_replace("%minute%", $mi, $format);
	$format=str_replace("%hour12%", $ho12, $format);
	$format=str_replace("%ampm%", $ampm, $format);
	$format=str_replace("%hour24%", $ho, $format);
	$format=str_replace("%day%", $da, $format);
	$format=str_replace("%daynum%", @date("w",$mktime), $format);
	$format=str_replace("%dayname%", lang ("days" , @date("w",$mktime)), $format);
	$format=str_replace("%weekday%", lang ("days" , @date("w",$mktime)), $format);
	$format=str_replace("%weeknum%", @date("W",$mktime), $format);
	$format=str_replace("%month%", $mo, $format);
	$format=str_replace("%monthname%", lang('months', -1+$mo), $format);
	$format=str_replace("%monname%", lang('months_abbr', -1+$mo), $format);
	$format=str_replace("%year%", $yr, $format);
	$format=str_replace("%ye%", substr($yr,2), $format);

	//while not part of 'dates', we also replace %title% with the
	//entry's, suitable for use in filenames
	$format=@str_replace("%title%", safe_string($db->entry['title'],TRUE) , $format);

	return $format;
}


// This will format $date, according to the passed $format
function format_date_range( $start_date, $end_date, $format) {
	global $Cfg, $current_date;
	
	list($st_yr,$st_mo,$st_da)=split("-",$start_date);
	list($en_yr,$en_mo,$en_da)=split("-",$end_date);

	$mktime = mktime(1,1,1,$st_mo,$st_da,$st_yr);

	$format=str_replace("%st_day%", $st_da, $format);
	$format=str_replace("%st_daynum%", @date("w",$mktime), $format);
	$format=str_replace("%st_dayname%", lang ( "days" , @date("w",$mktime)), $format);
	$format=str_replace("%st_weekday%", lang ( "days" , @date("w",$mktime)), $format);
	$format=str_replace("%st_weeknum%", @date("W",$mktime), $format);
	$format=str_replace("%st_month%", $st_mo, $format);
	$format=str_replace("%st_monthname%", lang('months', -1+$st_mo), $format);
	$format=str_replace("%st_monname%", lang('months_abbr', -1+$st_mo), $format);
	$format=str_replace("%st_year%", $st_yr, $format);
	$format=str_replace("%st_ye%", substr($st_yr,2), $format);


	$mktime = mktime(1,1,1,$en_mo,$en_da,$en_yr);

	$format=str_replace("%en_day%", $en_da, $format);
	$format=str_replace("%en_daynum%", @date("w",$mktime), $format);
	$format=str_replace("%en_dayname%", lang("days" , @date("w",$mktime)), $format);
	$format=str_replace("%en_weekday%", lang("days" , @date("w",$mktime)), $format);
	$format=str_replace("%en_weeknum%", @date("W",$mktime), $format);
	$format=str_replace("%en_month%", $en_mo, $format);
	$format=str_replace("%en_monthname%", lang('months',-1+$en_mo), $format);
	$format=str_replace("%en_monname%", lang('months_abbr',-1+$en_mo), $format);
	$format=str_replace("%en_year%", $en_yr, $format);
	$format=str_replace("%en_ye%", substr($en_yr,2), $format);

	return $format;
}



// print debug info..
function debug($line) {
global $Cfg;
	if (!isset($Cfg['debug']) || $Cfg['debug']==TRUE) {
		if(function_exists('memory_get_usage')) {
			$mem = " ( ". memory_get_usage() ." ) ";
		} else {
			$mem = "";
		}
		echo "<span class='timetaken'> -- ".timetaken()."- ".nl2br(htmlentities($line))." -- $mem</span><br />\n";
		flush();
	}

}


function array_size($arr) {

	ob_start();
	print_r($arr);
	$output = ob_get_contents();
	ob_end_clean();
	return (strlen($output));
}

function getmicrotime(){ 
    list($usec, $sec) = explode(" ",microtime()); 
    return ((float)$usec + (float)$sec); 
} 


// calculate time that was needed for execution
function timetaken($type="") {
global $starttime;
	$endtime = getmicrotime();
	$time_taken = $endtime - $starttime;
	$time_taken= number_format($time_taken, 3);  // optional

	if ($type=="int") {
		return $time_taken;
	} else {
		return "<span class='timetaken'>$time_taken</span>";
	}
}



function debug_trace($die=FALSE) {


	if(!function_exists('debug_backtrace')) {
		echo 'function debug_backtrace does not exists'."\r\n";
		return;
	}
  
	$MAXSTRLEN = 20;
	
	echo '<pre>';
	echo "\r\n".'--------------------------------'."\r\n";
	echo 'Debug backtrace:'."\r\n";
	
	$my_trace = array_reverse(debug_backtrace());
	
	foreach($my_trace as $t) 	{
		echo "  " . '&raquo; ';
		if(isset($t['file'])) {
			$line = "<strong>". basename($t['file']) ."</strong>:" . $t['line'];
			printf("%-42s", $line);
		} else {
			// if file was not set, I assumed the functioncall
			// was from PHP compiled source (ie XML-callbacks).
			echo '<PHP inner-code>';
		}

		echo ' &mdash; ';

		if(isset($t['class'])) echo $t['class'] . $t['type'];

		echo $t['function'];

		if (isset($t['args']) && sizeof($t['args']) > 0) {
			$args= array();
			foreach($t['args'] as $arg) {
        if (is_null($arg)) $args[] = 'null';
        else if (is_array($arg)) $args[] = 'Array['.sizeof($arg).']';
        else if (is_object($arg)) $args[] = 'Object:'.get_class($arg);
        else if (is_bool($arg)) $args[] = $arg ? 'TRUE' : 'FALSE';
        else if ( (is_int($arg))||(is_float($arg)) ) $args[] = $arg;
        else {
          $arg = (string) @$arg;
          $str = htmlspecialchars(substr($arg,0,$MAXSTRLEN));
					$str = str_replace("\n", "", str_replace("\r", "", $str));
					$str = preg_replace("/(\s)/i", " ", $str);
          if (strlen($arg) > $MAXSTRLEN) $str .= '~';
					
          $args[] = "'".$str."'";
          }
      }
			
			echo '( ' . implode(" , ", $args) .  ' )';
		}	else {
     echo '()';
    }

		echo "\r\n";
	}
	echo '--------------------------------'."\r\n";
	echo '</pre>';

	if ($die==TRUE) {
		exit;
	}
}



function start_timer($label) {
	global $timer_running_array, $timer_stopped_array, $timer_stack, $started_count;

	$started_count[] = $label;

	// if the last item on the stack is set, stop it.
	if (count($timer_stack)>0) {
		$stop = end($timer_stack);
		//debug("interrupt: ". $stop);

		if (isset($timer_running_array[$stop])) {
			$timer_stopped_array[$stop] += timetaken('int') - $timer_running_array[$stop];
			unset ($timer_running_array[$label]);
		}
	
	}

	//debug("start: $label");	
	$timer_running_array[$label] = timetaken('int'); 
	$timer_stack[]=$label;

}

function stop_timer($label) {
	global $timer_running_array, $timer_stopped_array, $timer_stack, $stopped_count;

	$stopped_count[] = $label;

	if (!isset($timer_stopped_array[$label])) { $timer_stopped_array[$label] = 0; }

	if (isset($timer_running_array[$label])) {
		//debug("stop $label:" . ( timetaken('int')  - $timer_running_array[$label]));
		$timer_stopped_array[$label] += timetaken('int') - $timer_running_array[$label];
		unset ($timer_running_array[$label]);

		array_pop($timer_stack);
		$continue = end($timer_stack);
		//debug("continue: ". $continue);

		$timer_running_array[$continue] = timetaken('int'); 

	} 

}

function print_timers() {
	global $timer_running_array, $timer_stopped_array, $timer_stack, $started_count, $stopped_count;

	if (!isset($started_count)) { return; }

	// see if we opened more than we closed..
	foreach ($started_count as $value) { $open_count[$value]++; }
	foreach ($stopped_count as $value) { $open_count[$value]--; }
	foreach ($open_count as $key => $value) {
		if ($value <> 0) {
			echo "<b>$key = $value</b><br />";
		}
	}

	arsort($timer_stopped_array);

	echo "<pre>timer array:";
	print_r($timer_stopped_array);
	echo "</pre>";

}

function getwysywigable() {

	$errorlevel= error_reporting(0);

	if (file_exists('includes/phpsniff/phpSniff.class.php')) {
			include_once('includes/phpsniff/phpSniff.class.php');
	} else {
		include_once('includes/phpsniff/phpsniff.class.php');
	}

  $client = new phpSniff('',0);
  $client->init();
	
	error_reporting($errorlevel);

	return ( ($client->is('b:ie5up')) && ($client->property('platform')=="win") );

}



// print a row in overview
function print_row(&$entry){
global $db, $global_pref, $linecount, $Pivot_Vars, $Users;

	if($entry['code']=="") { return; }

	if (!isset($linecount)) {
		$linecount=1;
	} else {
		$linecount++;
	}

	if (($linecount % 2)==0) { 
		$bg_color="tabular_line_even";
	} else {
		$bg_color="tabular_line_odd"; 
	}


	printf("	<tr class='%s'>\n", $bg_color);

	printf("<td><input type='checkbox' name='check[%s]'></td>",  $entry['code']);

	//if ( !isset($entry['status'])) { $entry['status']="hold"; }

	if ( $entry['status']=='publish' ) {
		//$pubdate = "published on: ". format_date($entry['publish_date'], "%day%-%monname%-%ye% %hour24%:%minute%");
		printf("		<td><a href=\"javascript:open_preview('%s')\">published</a>&nbsp;&nbsp;</td>\n", $entry['code']);
	} else {
		//$pubdate = "publish on: ". format_date($entry['publish_date'], "%day%-%monname%-%ye% %hour24%:%minute%");
		printf("		<td>%s&nbsp;&nbsp;</td>\n", $entry['status']);
	}

	// 


	// You can only edit your own entries or the entries of someone who has a 
	// lower userlevel, or if you're 'Admin'
	
	// to allow same level users to edit eachother's posts, use:
	// 	if ( ($Pivot_Vars['user']==$entry['user']) || ($Users[$Pivot_Vars['user']]['userlevel']>= 
	// $Users[$entry['user']]['userlevel']) || ($Users[$Pivot_Vars['user']]['userlevel']>=2) ) {
	
	if ( ($Pivot_Vars['user']==$entry['user']) || ($Users[$Pivot_Vars['user']]['userlevel']> $Users[$entry['user']]['userlevel']) || ($Users[$Pivot_Vars['user']]['userlevel']>=3) ) {
		$editurl=sprintf("index.php?session=%s&menu=entries&func=modify&id=%s", $Pivot_Vars['session'], $entry['code']);
		printf("		<td width='200'><span class='tabular'><a href='%s' title='%s'>%s</a></span></td>\n", $editurl, 'edit this entry',   trimtext($entry['title'], 30, TRUE));
	} else {
		printf("		<td width='200'><span class='tabular'><b>%s</b></span></td>\n",   trimtext($entry['title'], 30, TRUE));
	}

	if (is_array($entry['category'])) { 
		$mycat = implode(", ",$entry['category']);
	  printf("		<td><span title='%s'>%s</span></td>\n", $mycat, trimtext($mycat,14));
	} else {
		if ($entry['category']=="") { $entry['category']="(none)"; }
    printf("		<td>%s</td>\n", $entry['category']);
	}
    printf("		<td>%s</td>\n", $entry['user']);
	$date1= format_date($entry['date'], "%day%-%monname%-%ye% %hour24%:%minute%");
	//$date2= "created on: ". format_date($entry['edit_date'], "%day%-%monname%-%ye% %hour24%:%minute%")." / last edited on: ". format_date($entry['edit_date'], "%day%-%monname%-%ye% %hour24%:%minute%");
    printf("		<td class='tabular'>%s</td>\n", $date1);
	if ($entry['commcount']>0) {

		// You're only allowed to edit comments for your own entries if you're userlevel 2, 
		// or for other entries if you're admin.
		if (  ( ($Pivot_Vars['user']==$entry['user']) && ($Users[$Pivot_Vars['user']]['userlevel']>=2) ) || ($Users[$Pivot_Vars['user']]['userlevel']>=3) ) {
			$commurl=sprintf("index.php?session=%s&menu=entries&func=editcomments&id=%s", $Pivot_Vars['session'], $entry['code']);
			printf("		<td><a href='%s' title=\"%s\">%s</td>\n", $commurl, $entry['cnames'], $entry['commcount']);
		} else {
			printf("		<td>%s</td>\n", $entry['commcount']);
		}

	
	} else {
		printf("		<td>0</td>\n");
	}
	printf("	</tr>\n\n");

}




// print a row in overview
function print_row_overview(&$entry){
global $db, $global_pref, $linecount, $Pivot_Vars, $Users;

	if($entry['code']=="") { return; }

	if (!isset($linecount)) {
		$linecount=1;
	} else {
		$linecount++;
	}

	if (($linecount % 2)==0) { 
		$bg_color="tabular_line_even";
	} else {
		$bg_color="tabular_line_odd"; 
	}


	printf("	<tr class='%s'>\n", $bg_color);


	// You can only edit your own entries or the entries of someone who has a 
	// lower userlevel, or if you're 'Admin'
	if ( ($Pivot_Vars['user']==$entry['user']) || ($Users[$Pivot_Vars['user']]['userlevel']> $Users[$entry['user']]['userlevel']) || ($Users[$Pivot_Vars['user']]['userlevel']>=3) ) {
		$editurl=sprintf("index.php?session=%s&menu=entries&func=modify&id=%s", 
								$Pivot_Vars['session'], $entry['code']);
		printf("		<td><span class='tabular'><a href='%s' title='%s'>%s</a></span></td>\n", 
				$editurl, 'edit this entry',   trimtext($entry['title'], 22, TRUE));
	} else {
		printf("		<td><span class='tabular'><b>%s</b></span></td>\n",   
				trimtext($entry['title'], 22, TRUE));
	}

	/*
	if (is_array($entry['category'])) { 
		$mycat = implode(", ",$entry['category']);
	    printf("		<td><span title='%s'>%s</span></td>\n", $mycat, trimtext($mycat,14));
	} else {
		if ($entry['category']=="") { $entry['category']="(none)"; }
    printf("		<td>%s</td>\n", $entry['category']);
	}
	*/

    printf("		<td>%s</td>\n", $entry['user']);
	$date1= format_date($entry['date'], "%day%-%monname%-%ye%");
	//$date2= "created on: ". format_date($entry['edit_date'], "%day%-%monname%-%ye% %hour24%:%minute%")." / last edited on: ". format_date($entry['edit_date'], "%day%-%monname%-%ye% %hour24%:%minute%");
    printf("		<td class='tabular'>%s</td>\n", $date1);
	if ($entry['commcount']>0) {

		// You're only allowed to edit comments for your own entries if you're userlevel 2, 
		// or for other entries if you're admin.
		if (  ( ($Pivot_Vars['user']==$entry['user']) && ($Users[$Pivot_Vars['user']]['userlevel']>=2) ) || ($Users[$Pivot_Vars['user']]['userlevel']>=3) ) {
			$commurl=sprintf("index.php?session=%s&menu=entries&func=editcomments&id=%s", $Pivot_Vars['session'], $entry['code']);
			printf("		<td><a href='%s' title=\"%s\">%s</td>\n", $commurl, $entry['cnames'], $entry['commcount']);
		} else {
			printf("		<td>%s</td>\n", $entry['commcount']);
		}

	
	} else {
		printf("		<td>0</td>\n");
	}
	printf("	</tr>\n\n");

}


function last_comments_overview() {
	global $Pivot_Vars;

	@$lastcomments =	array_reverse(load_serialize("db/ser_lastcomm.php", true, true));

	if (count($lastcomments)>0) {

		printf('<table cellspacing="0" class="tabular_border" border="0" width="360" style="margin-top:6px;"><tr class="tabular_nav">');
		printf('<td colspan="2">' . lang('userbar','recent_comments') . '</td></tr>', $prevlink);
		echo '<tr class="tabular_header"><td>'. lang('entries', 'name') .'</td>';
		echo '<td>'. lang('entries', 'date') .'</td>';
		echo '</tr>';

		$linecount = 1;
		foreach ($lastcomments as $lastcomment) {

			if (($linecount % 2)==0) { 
				$bg_color="tabular_line_even";
			} else {
				$bg_color="tabular_line_odd"; 
			}

			$link=sprintf("index.php?session=%s&menu=entries&func=editcomments&", $Pivot_Vars['session']);
			$link=sprintf("%sid=%s#%s", $link, $lastcomment['code'], $lastcomment['date']);


			$name = trimtext($lastcomment['name'], 22, FALSE);
			$date = format_date($lastcomment['date'], "%day%-%monname%-%ye% %hour24%:%minute%");
			$comm = trimtext($lastcomment['comment'], 80, FALSE);
			$comm = mywordwrap($comm, 20, "  ", 1);

			printf("<tr class='%s'><td style='white-space: nowrap;'><small><a href='%s'>%s</a><br />%s</small></td>", $bg_color, $link, $name, $date);
			printf("<td valign='top' style='white-space: normal;'><small>%s</small></td></tr>",  $comm);
		
			if ( ($linecount++)>4) { break; }

		}


		echo "</table><br />";

	}


}

function gettemplates($filter="") {
	$d= dir("templates");
	while ($entry=$d->read()) {
		$ext=getextension($entry);
		if (($ext=="htm")||($ext=="html")) {
			
			$templates[]= $entry;
			$templates[]= $entry;

		}
	}
	$d->close();
	
	if ($filter!="") {
		
		foreach ($templates as $template) {
			if (strpos($template, $filter) !== FALSE) {
				$filtered[]=$template;
			}
		}

		// only filter if there are at least two (otherwise it breaks for people who 
		// do upgrades)..
		if (count($filtered)>4) {
			return $filtered;
		} else {
			return $templates;
		}
	
	} else {
		return $templates;
	
	}

}


// return a bit of HTML to insert a <select> with all available categories
function get_categories_select($type="single") {
	global $db, $Cfg;
	
	$output="";
	$cats= explode("|", $Cfg["cats"]);

	if (isset($db)) {
		$this_cat=$db->entry['category'];
	} else {
		// set a default category..
		$this_cat=array($cats[0]);
	}

	if ($type=="single") {

		$output="<select name='f_catsing' class='input' id='f_catsing' onChange='syncCat1(this);'>";

		foreach ($cats as $cat) {
			
			$cat= trim($cat);
			@$sel = (in_array($cat, $this_cat)) ? " selected" : "";
			$output.="<option value='$cat'$sel>$cat</option>\n";

			
		}

		$selmul = (count($this_cat)>1) ? " selected" : "";
		$selnone = (count($this_cat)<1) ? " selected" : "";

		$output.="<option value='(multiple)' ".$selmul.">(multiple)</option>\n";
		$output.="<option value='(none)' ".$selnone.">(none)</option>\n";

		$output.="</select>&nbsp;";
	} else {

		$output="<select name='f_catmult[]' size='6' multiple class='input' id='f_catmult' onChange='syncCat2(this);'>";
		foreach ($cats as $cat) {
			$cat= trim($cat);
			@$sel = (in_array($cat, $this_cat)) ? " selected" : "";
			$output.="<option value='$cat'$sel>$cat</option>";
		}

		$output.="</select>&nbsp;";

	}



	return $output;
}


// return the number of categories
function get_categories_num() {
	$output="";

	if (isset($this->globals['categories'])) {
		return (count($this->globals['categories']));
	} else {
		return 0;
	}
}


// return $Cfg['cats'] as an array. sorted and without empty ones
function cfg_cats() {
	global $Cfg;

	$cats = explode("|", $Cfg['cats']);
	natcasesort($cats);
	
	foreach ($cats as $key => $cat) {
		if ($cat=="") { unset($cats[$key]); }
	}

	return $cats;
}


// This function is used to find which weblogs publicize a certain category
function find_weblogs_with_cat($cats) {
	global $Weblogs;

	// $cats might be a string with one cat, if so, convert to array
	if (is_string($cats)) {
		$cats= array($cats);
	}

	$res=array();

	// search every weblog for cat.
	foreach ($Weblogs as $key => $weblog) {

		// search each weblogs' sublogs
		foreach ($weblog['sub_weblog'] as $subweblog) {

			// search each element of the passed argument $cats
			if (is_array($cats)) {
				foreach ($cats as $cat) {
					if (in_array($cat, $subweblog['categories'])) {
						$res[]=$key;
					}
				}
			}
		}

	}
	return array_unique($res);

}


// merge a split date 
function fix_date($date, $time) {
	//debug("date: $date , $time " );

	list($day,$month,$year)=split('[ /.:-]',$date);
	@list($hour,$minute,$sec)=split('[ /.:-]',$time);

	//$reverse_month=array_flip ($lang['Months']);

	//$month=1+$reverse_month[$month];

	return sprintf("%04d-%02d-%02d-%02d-%02d", $year, $month, $day, $hour, $minute);

}

// will return an absolute path to and index or archive page..
function get_log_url($type) {
	global $Weblogs, $Current_weblog, $db, $Paths;

	if ($type=='index') {
		if ($Weblogs[$Current_weblog]['front_path'][0] == '/') {
			$path = $Weblogs[$Current_weblog]['front_path'] . $Weblogs[$Current_weblog]['front_filename'];
		} else {
			$path = $Paths['pivot_url'] . $Weblogs[$Current_weblog]['front_path'] . $Weblogs[$Current_weblog]['front_filename'];
		}
		$path = fixPath($path);
	}
	
	//debug ("path: ".$path);

	return $path;

}

// fixPath fixes a relative path eg. '/site/pivot/../index.php' becomes '/site/index.php';
function fixPath($path) {
	$path = str_replace("\/", "/", $path);
	$path      = ereg_replace('/+', '/', $path);
	$patharray = explode('/', $path);
	foreach ($patharray as $item) {
		if ($item == "..") {
			// remove the previous element
			@array_pop($new_path);
		} else if ( ($item != ".") ) {
			$new_path[]=$item;
		}
	}
	return implode("/", $new_path);
}


// an easy function to recursively create chmodded directory's
function makedir($name) {

	// if it exists, just return.
	if (file_exists($name)) {
		return;
	}

	// if more than one level, try parent first..
	if (dirname($name) != ".") {
		makedir(dirname($name));
	}

	$oldumask = umask(0);
	@mkdir ($name, 0777);
	@chmod ($name, 0777);
	umask($oldumask);

}



function buildfrontpage_function() {
	global $db, $Pivot_Vars, $Cfg, $VerboseGenerate, $pivot_path;

	$db = new db();

	$overview_arr = $db->getlist(-4,0,"","", FALSE);

	$VerboseGenerate = TRUE;

	foreach ($overview_arr as $entry) {
		generate_pages($entry['code'], TRUE, TRUE, TRUE, FALSE);
	}

}




function getdaterange($date, $unit) {

	$numdaysin = array(0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

	list($yr,$mo,$da,$ho,$mi)=split("-",$date);

	$yr_min = $yr_max = $yr;
	$mo_min = $mo_max = $mo;

	if ($unit=='day') {

		$range_min = date("Y-m-d-00-00", mktime(0,0,0,$mo,$da,$yr));
		$range_max = date("Y-m-d-23-59", mktime(0,0,0,$mo,$da,$yr));

	} else if ($unit=='week') {

		$dow = ((@date("w", mktime(0,0,0,$mo,$da,$yr)) + 6) % 7);
		$range_min = @date("Y-m-d-00-00", mktime(0,0,0,$mo,($da-$dow),$yr));
		$range_max = @date("Y-m-d-23-59", mktime(0,0,0,$mo,($da-$dow+6),$yr));

	} else if ($unit=='month'){

		$da_min = '01';
		$da_max = $numdaysin[(0+$mo_max)];

		// put the ranges back together.
		$range_min = sprintf("%02d-%02d-%02d-00-00", $yr_min,$mo_min,$da_min);
		$range_max = sprintf("%02d-%02d-%02d-23-59", $yr_max,$mo_max,$da_max);
	
	} else {

		$mo_min = '01';
		$mo_max = '12';
		$da_min = '01';
		$da_max = '31';

		// put the ranges back together.
		$range_min = sprintf("%02d-%02d-%02d-00-00", $yr_min,$mo_min,$da_min);
		$range_max = sprintf("%02d-%02d-%02d-23-59", $yr_max,$mo_max,$da_max);

	}

	return array($range_min, $range_max);

}


function entries_action ($do_action, $do_entries) {

	// if deleting, this is serialized
	if (!is_array($do_entries)) {
		$do_entries = unserialize(stripslashes($do_entries));
	}


	foreach ($do_entries as $do_entry => $dummy) {
		if ($do_action=="delete") { entries_action_delete($do_entry); }
		if ($do_action=="hold") { entries_action_hold($do_entry); }
		if ($do_action=="publish") { entries_action_publish($do_entry); }
		if ($do_action=="generate") { entries_action_generate($do_entry); }
	}

	buildfrontpage_function();

}


function entries_action_delete($code) {
	global $db, $Pivot_Vars, $Users;

	$db = new db();
	$db->read_entry($code);

	// checking to see whether user is allowed to delete the entry goes here
	if ( ($Pivot_Vars['user'] == $db->entry['user']) || ($Users[$Pivot_Vars['user']]['userlevel'] >= 3) ) {
		

		@$last_comms =	load_serialize("db/ser_lastcomm.php", true, true);
		if (count($last_comms)>0) {
			foreach ($last_comms as $key => $last_comm) {
				if ( ($last_comm['code'] == $entry['code'])	){					
					unset($last_comms[$key]);
					save_serialize("db/ser_lastcomm.php", $last_comms );				
				}
			}
		}

		$db->delete_entry();

	} else {
		$msg = "You are not allowed to delete entry %title%!";
		$msg = str_replace("%title%", "'".$db->entry['title']."'", $msg);
		echo $msg."<br />";
	}
}


function entries_action_hold($code) {
	global $db, $Pivot_Vars, $Users;

	$db = new db();
	$db->read_entry($code);

	// checking to see whether user is allowed to delete the entry goes here
	if ( ($Pivot_Vars['user'] == $db->entry['user']) || ($Users[$Pivot_Vars['user']]['userlevel'] >= 3) ) {	
		$entry= $db->entry;
		$entry['status']="hold";

		$db->set_entry($entry);
		$db->save_entry();

	} else {
		$msg = lang('general', 'cantdothat');
		$msg = str_replace("%title%", "'".$db->entry['title']."'", $msg);
		echo $msg."<br />";
	}
}

function entries_action_publish($code) {
	global $db, $Pivot_Vars, $Users;

	$db = new db();
	$db->read_entry($code);

	// checking to see whether user is allowed to delete the entry goes here
	if ( ($Pivot_Vars['user'] == $db->entry['user']) || ($Users[$Pivot_Vars['user']]['userlevel'] >= 3) ) {	
		$entry= $db->entry;
		$entry['status']="publish";
		$db->set_entry($entry);
		$db->save_entry();

	} else {
		$msg = lang('general', 'cantdothat');
		$msg = str_replace("%title%", "'".$db->entry['title']."'", $msg);
		echo $msg."<br />";
	}
}

function entries_action_generate($code) {
	global $db, $Pivot_Vars, $Users;

	$db = new db();
	$db->read_entry($code);

	// checking to see whether user is allowed to delete the entry goes here
	if ( ($Pivot_Vars['user'] == $db->entry['user']) || ($Users[$Pivot_Vars['user']]['userlevel'] >= 3) ) {	
		$entry= $db->entry;
		if ($entry['status']!="publish") {
			$entry['status']="publish";
			$db->set_entry($entry);
			$db->save_entry();
		}
		generate_pages($entry['code'], TRUE, TRUE, TRUE, FALSE);
	} else {
		$msg = lang('general', 'cantdothat');
		$msg = str_replace("%title%", "'".$db->entry['title']."'", $msg);
		echo $msg."<br />";
	}
}


function files_action ($do_action, $do_files) {


	foreach ($do_files as $do_file => $dummy) {
		// echo "$do_action - $do_file<br />";
		if ($do_action=="delete") { files_action_delete($do_file); }

	}

}

function files_action_delete($name) {
	global $Cfg, $Pivot_Vars;

	if($Pivot_Vars['do'] == 'templates') {
		// NOTE: 13-4-2003
		// Must be changed to $Cfg['templates_path'] !!!!!!
		chdir('templates/');
		unlink($name);
		chdir('../');
	} else {
		$file = "../".$Cfg['upload_path'] . $name;
		//echo "file: ".$file."<br />";
		unlink($file);
	}

	// also force the archive index file to be updated
	@unlink('db/ser-archives.php');

}


function init_emoticons() {
	global $emot, $emot_path, $base_url, $Paths;

	if(!defined('_EMOTICONS_INCLUDED'))  {
		define('_EMOTICONS_INCLUDED',1);
	
		include ("includes/emoticons.php");
		foreach ($emot as $emot_code => $emot_file) {
			$path = fixpath(sprintf("%s%s%s", $Paths['pivot_url'], $emot_path, $emot_file));
			$align = set_target("", " align='middle'");
			$emot[$emot_code]=sprintf("<img src='%s' alt='%s'%s/>", $path, addslashes($emot_code), $align);
		}
	}
}

function emoticonize($text) {
	global $emot;

	init_emoticons();

	foreach ($emot as $emot_code => $emot_html) {
		$text=str_replace($emot_code, $emot_html, $text);
	}
	return $text;
}



function targetblank($text, $autoredirect=FALSE) {
	global $Weblogs, $Current_weblog, $Cfg, $pivot_url;

	if ( $Weblogs[$Current_weblog]['target_blank']==1 ) {
		if (strpos($text, "target='_blank'") === FALSE) {
			$text = preg_replace("'<a href=[\"|\'](.*[^>])[\"|\']([^<>]*)>(.*)</a>'iUs", "<a href=\"\\1\" \\2 target='_blank'>\\3</a>",$text);
		}
	} else if ( $Weblogs[$Current_weblog]['target_blank']==2 ) {
		if (strpos($text, "rel='external'") === FALSE) {
			$text = preg_replace("'<a href=[\"|\'](.*[^>])[\"|\']([^<>]*)>(.*)</a>'iUs", "<a href=\"\\1\" \\2 rel='external'>\\3</a>",$text);
		}
	}

	if ($autoredirect) {
		$text=str_replace("http://", $pivot_url."includes/re.php?http://", $text);
	}

	return $text;

}



// this function will replace a portion of a string $text
// with x's starting at position $leftpos through to position $rightpos
// $text is passed by reference...
function blankout(&$text, $leftpos, $rightpos) {
	while ($leftpos<=$rightpos) {
		$text[$leftpos]="x";
		$leftpos++;
	}
}


// get_attr_value
//
// This function will search $attributes for the value for the
// the attribute in $att_name.
// for example, after calling:
// $my_value=get_attr_value('size', 'color="green" size="12"');
// my_value will contain 12
function get_attr_value($att_name, $attributes) {
	// first, we need do do some tricks to find out where we'll have
	// to split the $attributes string
	
	$attributes=stripslashes(str_replace("&quot;",'"', $attributes));
	$this_attr=substr($attributes, strpos($attributes,$att_name));
	$pos=strpos($attributes,$att_name);

	if (preg_match("/$att_name=\"([^\"]*)\"/i", $attributes, $parts)) {
		return $parts[1];
	} else {
		return "";
	}
}


function init_encode_table() {
	global $encode_html,$encode_html_slim, $decode_html;

	// To encode funny characters like  to &eacute; we use
	// the standard php-functions. 
	$encode_html=get_html_translation_table(HTML_ENTITIES);

	// unfortunately, these are not complete, so we add some more..
	$encode_html['']="&#0145;";
	$encode_html['']="&#0146;";
	$encode_html['']="&#0130;";
	$encode_html['']="&#0147;";
	$encode_html['']="&#0148;";
	$encode_html['']="&#0153;";
	$encode_html['']="&oelig;";
	$encode_html['']="&euro;";
	$encode_html['']="&hellip;";
	//$encode_html['']="";

	// The array to translate entities to funny characters..
	$decode_html=array_flip($encode_html);     

	$encode_html_slim =  $encode_html;
	
	unset($encode_html_slim['"']);
	unset($encode_html_slim["'"]);
	unset($encode_html_slim['<']);
	unset($encode_html_slim['>']);
	
	/* echo "<pre>";
	print_r($encode_html_slim);
	echo "</pre>";
	
	echo(count($encode_html)."<BR>");
	echo(count($encode_html_slim)."<br>");
	*/
}


function escape($i) {
	//global $encode_html, $decode_html;

	$i = stripslashes($i);
	//$i = strtr($i, $decode_html);

	// according to the php manual, these have to be translated back
	// in order to output proper html
	// '&' (ampersand) becomes '&amp;' 
	// '"' (double quote) becomes '&quot;' when ENT_NOQUOTES is not set. 
	// ''' (single quote) becomes '&#039;' only when ENT_QUOTES is set. 
	// '<' (less than) becomes '&lt;' 
	// '>' (greater than) becomes '&gt;' 

	$i = str_replace ('&lt;', '<', $i);
	$i = str_replace ('&gt;', '>', $i);
	$i = str_replace ('&quot;', '"', $i);
	$i = str_replace ('&#039;', "'", $i);
	$i = str_replace ('&amp;', "&", $i);
	
	return $i;
}



// This function makes &eacute; out of , but leaves html tags alone..
// useful for storing comments..
function entify($i) {
	global $encode_html_slim;

	if (!isset($encode_html_slim)) {
		init_encode_table();
	}

	$i = strtr($i, $encode_html_slim);
	
	// these have to be translated back in order to output html-tags
	//$i = str_replace ('&lt;', '<', $i);
	//$i = str_replace ('&gt;', '>', $i);
	//$i = str_replace ('&quot;', '"', $i);
	//$i = str_replace ('&#039;', "'", $i);
	//$i = str_replace ('&amp;', "&", $i);
	
	return $i;
}


// This function makes  out of &eacute; 
function unentify($i) {
	global $encode_html, $decode_html;

	if (!isset($encode_html)) {
		init_encode_table();
	}

	$i = strtr($i, $decode_html);
	
	return $i;
}




function xml2html($i) {

	$i=htmlentities($i);
	
	$i = str_replace ('&lt;', '<', $i);
	$i = str_replace ('&gt;', '>', $i);
	$i = str_replace ('&quot;', '"', $i);
	$i = str_replace ('&#039;', "'", $i);
	$i = str_replace ('&amp;', "&", $i);
	
	return $i;
	
}


function addquotes($i) {

	$i= str_replace("'", '&#039;', $i);
	$i= str_replace('"', '&quot;', $i);
	
	return $i;

}


function addltgt($i) {

	$i= str_replace('&gt;', '&amp;gt;', $i);
	$i= str_replace('&lt;', '&amp;lt;', $i);
	
	return $i;

}


// check if $text is word-html-crap (ie. pasted from word)
function is_word_html($text) {
	
	$a = strpos($text, "<o:p></o:p>");
	$b = strpos($text, "MsoNormal");
	$c = strpos($text, "mso-bidi");
	$d = strpos($text, "xml:namespace");
	
	//echo "$a - $b - $c - $d";

	return ($a || $b || $c || $d);
}



// make sure n00b users cannot post < ? echo "pom"; ? > and the like..
function strip_scripting($text) {
	global $Pivot_Vars, $Users;
		
	if($Users[$Pivot_Vars['user']]['userlevel'] < 3) {
		// all users that are not administrator..
		$text = str_replace("<?", "&lt;?", $text);
		$text = str_replace("?".">", "?&gt;", $text);
		$text = str_replace("<%", "&lt;%", $text);
		$text = str_replace("%".">", "%&gt;", $text);
		return $text;
	} else {
		return $text;
	}

}



// clean up word html..
function strip_word_html($text) {
	
//	echo "\n\n\n\n<hr>$text<hr>";

	$text = stripslashes($text);
	$text = str_replace("<?xml:namespace", "<pom", $text); 
	$text = strip_tags($text,'<b><i><u><a><br><p><em><strong>');
	$text = ereg_replace ("<a[^>]+href *= *([^ ]+)[^>]*>", "<a href=\\1>", $text);
	$text = ereg_replace ("<([b|i|u|br|p|em|strong])[^>]*>","<\\1>", $text);

	return $text;
}


// rewrite of php's wordwrap function, so it won't break entities like &eacute;
function mywordwrap($i, $width=25, $break="  ", $cut=1) {

	$i = unentify($i);
	$i = wordwrap($i, $width, $break, $cut);
	$i = entify($i);

	return $i;

}



// Trim a text to a given length, taking html entities into account.
function trimtext($str, $length, $nbsp=FALSE) {

	$str = strip_tags($str);

	if (strlen($str)>$length) {
		$str = unentify($str);
		$str=substr($str,0,$length+1);
		$str = entify($str)."&hellip;";
	}

	if ($nbsp==TRUE) {
		$str=str_replace(" ", "&nbsp;", $str);
	}

	$str=str_replace("http://", "", $str);

	return $str;

}



function encodemail_link($mail, $nick, $title="") {
	global $Weblogs , $Current_weblog;

	if ($mail=="") {
		return $nick;
	} else {
		$mail=strip_tags($mail);
	}

	if ($title=="") {
		$title=$nick;
	} else {
		$title=strip_tags($title);
	} 

	$title= str_replace("'", '&#039;', $title);
	$title= str_replace('"', '&quot;', $title);

	if ($Weblogs[$Current_weblog]['encode_email_addresses']) {
		include_once "modules/safeaddress.inc.php";
		$mail = safeAddress($mail, $nick, "email $title", 1, 0);
		return $mail;
	} else {
		return "<a href='mailto:$mail' title='email ".addslashes($title)."'>$nick</a>";
	}

}


// Wrapper for Textile.. Use textile 2, but if it's not there, use textile 1
function pivot_textile($str) {

	if (file_exists("includes/textile/classtextile.php")) {
	
		include_once "includes/textile/classtextile.php";
		$textile = new Textile;
		return $textile->TextileThis($str);
		
	} else if (file_exists("includes/textile/textile.php")) {
	
		include_once 'includes/textile/textile.php';
		
		return textile($str);
	
	} else {
	
		return $str;
		
	}

}


// for the comments we use this function..
// we strip _all_ tags except <b> and <i> and after that
// we convert everything that looks like a url or mail-adress
// to the equivalent link.. very nifty.. 
function comment_format($text) {
global $Cfg, $Weblogs , $Current_weblog, $Paths;
	
	$text=strip_tags($text,"<b>,<i>,<em>,<strong>");

	//$text=xml2html($text);

	if ( (isset($Cfg['comment_wrap'])) && ($Cfg['comment_wrap']>0) && check_php_version('4.0.3') ) {
		$text= wordwrap( $text, $Cfg['comment_wrap'], " ", 1);
	}

	if ($Weblogs[$Current_weblog]['comment_textile']==1) { 
		// the old-style automatic links are converted to textile links.	
		// (bit of an ugly fix, but it works..


		$text = preg_replace("/([ \t]|^)www\./Ui"," http://www.",$text);
		$text = preg_replace("/(http:\/\/[^ )\r\n]+)/i","\"[[\\1]]\":\\1",$text);
		// fix wrongfully matched links
		$text = preg_replace("/:\"\[\[(.*)\]\]\":/Ui", ":", $text);
		// fix wrongfully matched images
		$text = preg_replace("/!\"\[\[(.*)!\]\]\":/Ui", "!", $text);

			
		$text = eregi_replace("([-a-z0-9_]+(\.[_a-z0-9-]+)*@([a-z0-9-]+(\.[a-z0-9-]+)+))","<A HREF=\"mailto:\\1\">\\1</A>",$text);


		$text = pivot_textile( $text );

	} else {
		
		$text = eregi_replace("([ \t]|^)www\."," http://www.",$text);
		$text = eregi_replace("([ \t]|^)ftp\."," ftp://ftp.",$text);
		$text = eregi_replace("(http://[^ )\r\n]+)","<A href=\"\\1\"$target>[[\\1]]</A>",$text);
		$text = eregi_replace("(https://[^ )\r\n]+)","<A href=\"\\1\"$target>[[\\1]]</A>",$text);
		$text = eregi_replace("(ftp://[^ )\r\n]+)","<A href=\"\\1\"$target>[[\\1]]</A>",$text);
		$text = eregi_replace("([-a-z0-9_]+(\.[_a-z0-9-]+)*@([a-z0-9-]+(\.[a-z0-9-]+)+))","<A HREF=\"mailto:\\1\">\\1</A>",$text);
		
		$text = nl2br($text);

	}	
	
	
	// then make long urls into short urls, with correct link..
	preg_match_all ("|\[\[(.*)\]\]|U", $text, $match, PREG_PATTERN_ORDER);

	foreach($match[1] as $url) {
		if (strlen($url)>40) { 
			$s_url=substr($url,0,40).".."; 
		} else {
			$s_url=$url;
		}
		$text=str_replace("[[".$url."]]", $s_url, $text);
	} 


	if  ( ($Weblogs[$Current_weblog]['target_blank']==1) ) {
		$target=" target=\"_blank\"";
	} else {
		$target="";
	}
		

	//perhaps redirect the link..
	if (isset($Weblogs[$Current_weblog]['lastref_redirect'])  && ($Weblogs[$Current_weblog]['lastref_redirect']==1) ) {
			$text = str_replace("href=\"http://", "href=\"".$Paths['pivot_url']."includes/re.php?http://",  $text);
	} 


	if ($Weblogs[$Current_weblog]['emoticons']==1) {
		$text=emoticonize($text);
	}
	
	return (stripslashes($text));	
}

// tests a file, and outputs some information about that file.
function testfile($name) {
	global $testfile_array;

	if (file_exists($name)) {
		echo "- This file does exist";
		if (is_writable($name)) {
			echo " and is writable!";
		} else {
			echo " and is <b>not</b> writable";
		}
	} else {

		if (strpos("$name", "%")>0) {
			// special case for archives and entries
			if (is_writable(dirname($name))) {
				echo "- These files <b>can</b> be created by Pivot!";
			} else {
				echo "- These files can <b>not</b> be created either. <br />&nbsp;&nbsp;Please check the rights of the following folder using your FTP program :<br />&nbsp;&nbsp;<span class='filename'>". dirname(realpath($name))."</span>";
			}

		} else {
			// all other cases
			echo "- This file does <b>not</b> exist";
			if (is_writable(dirname($name))) {
				echo " but <b>can</b> be created by Pivot! (no action required)";
			} else {
				echo " and can <b>not</b> be created either. <br />&nbsp;&nbsp;Please check the rights of the following folder using your FTP program :<br />&nbsp;&nbsp;<span class='filename'>". dirname(realpath($name))."</span>";
			}
		}
	}

	echo "<br />\n";

	if (!isset($testfile_array[$name])) {
		$testfile_array[$name] = TRUE;
	} else {
		$str = "Another Weblog also writes to this file!! You should really change the settings on this weblog or on the other one!";
		echo "- <b>".wordwrap($str, 80, "<br />&nbsp;\n")."</b><br />\n";
	}

}


// This function loads a serialized file, unserializes it, and returns it
function load_serialize($filename, $silent=FALSE, $force=FALSE) {
	global $serialize_cache;

		
	// cache no more than 10 items, to keep memory from going insane..
	if (count($serialize_cache) > 8 ) {
		// we remove the first entry, assuming that is the one that is least likely to be needed again.
		array_shift($serialize_cache);
	} 
	
	if ($force) {
		//debug("FORCE: $filename");
		unset($serialize_cache[$filename]);
	}
	
	if (isset($serialize_cache[$filename])) {
		// if it's in the cache..
		
		//debug("serialize cache: ".$filename. "(".count($serialize_cache).")");
		return $serialize_cache[$filename];
		
	} else if (file_exists($filename)) {
		// else get it from the filesystem..
		
	
		@$fh = fopen( $filename, 'r' );

		if (!$fh) {
			$message = str_replace("%name%", $filename, "A needed file ('%name%') does exist, but pivot is not allowed to read it. <br /><br />Try logging in with your ftp-client and check to see if it is chmodded to be readable by the webuser (ie: 766). Else go <a href='javascript:history.go(-1)'>back</a> to the last page.");
			piv_error("File is not readable!", $message, 0);
		}

		$serialized_data = fread($fh, filesize($filename));
		if (@$data = unserialize($serialized_data)) {
			$serialize_cache[$filename] = $data;
			return $data;
		} else {
			$temp_serialized_data = preg_replace("/\r\n/", "\n", $serialized_data);
			if (@$data = unserialize($temp_serialized_data)) {
				$serialize_cache[$filename] = $data;
				return $data;
			} else {
				$temp_serialized_data = preg_replace("/\n/", "\r\n", $serialized_data);
				if (@$data = unserialize($temp_serialized_data)) {
					$serialize_cache[$filename] = $data;
					return $data;
				} else {
					//debug("could not deserialize $filename!");
					return FALSE;
				}
			}
		}
	
	} else {

			if ($silent) {
				return array();
			} else 
				$message = str_replace("%name%", $filename, "One of the files needed ('%name%') could not be found. <br /><br />This can normally be fixed by recreating the index-file (when you are logged into pivot as an admin user). Else go <a href='javascript:history.go(-1)'>back</a> to the last page.");

				piv_error("File Does not Exist!", $message, 0);

	}
	

}

// This function serializes some data and then saves it.
function save_serialize($filename, &$data) {
	global $Cfg;

	$ser_string = serialize($data);

	// disallow user to interrupt
	ignore_user_abort(TRUE);

	$old_umask = umask(0111);

	if (($Cfg['unlink'] == 1) && (file_exists($filename))) { 
		/* unlinking is good for some safe_mode users */
		/* and bad for some others.. i hate safe_mode */
		@unlink($filename); 
	} 
	
	// open the file and lock it.
	if($fp=fopen($filename, "w")) {
		flock( $fp, LOCK_EX );

		// write it
		if (fwrite($fp, $ser_string)) {
			flock( $fp, LOCK_UN );
			fclose($fp); 
		} else {
			piv_error("Error writing file",  "The file <b>$filename</b> could not be written!");
			return FALSE;
		}
	} else {
			piv_error("Error opening file",  "The file <b>$filename</b> could not be opened for writing!");
			return FALSE;
	}
	umask($old_umask);

	// reset the users ability to interrupt the script
	ignore_user_abort(FALSE);


	return TRUE;

}



// saves a file, and outputs some feedback, if wanted..
function write_file($filename, $output) {
	global $VerboseGenerate, $Cfg;

	if ($VerboseGenerate) { echo lang('general', 'write').": ".$filename."<br />\n"; }

	// open up..
	if(!$fh = fopen( $filename, 'w' )) {
		if ($VerboseGenerate) { echo lang('general', 'write_open_error').": ".$filename."<br />\n"; }
	}

	// wrrrriting!
	if(!fwrite($fh, $output)) {
		if ($VerboseGenerate) { echo lang('general', 'write_write_error').": ".$filename."<br />\n"; }
	}
	

	fclose( $fh );
	$oldumask = umask(0);
	// to avoid typecasting misery, just use some ugly hardcoded if's
	if ($Cfg['chmod']=='0777') {
		@chmod ($filename, 0777);
	} else if ($Cfg['chmod']=='0755') {
		@chmod ($filename, 0755);
	} else if ($Cfg['chmod']=='0666') {
		@chmod ($filename, 0666);
	} else if ($Cfg['chmod']=='0655') {
		@chmod ($filename, 0655);
	} else {
		@chmod ($filename, 0644);
	}
	umask($oldumask);

}




// redirect. first through header, otherwise by javascript..
function redirect($url, $rand = 0, $die=1) {
	global $Cfg, $Current_weblog;

	// to make sure the visitor gets to see the new page, we redirect with a dummy parameter..
	if ($rand==1) {
		srand ((double) microtime() * 1000000);
		$randval = rand();
	    $url.="?r=".$randval;
	}


	if ($Cfg['debug']==1) {
		echo "<a href=\"$url\">$url</a>";
		if ($die==1) { die(); } else { echo "don't die"; }
	} else {
		header("Location: ".$url);
		echo "<script>self.location='$url';</script>";
		if ($die==1) { die(); } else { echo "don't die"; }
	}

}

// wrapped by a 'function_exists', since it might already be defined..
if (!function_exists('safe_string')) {
	function safe_string($str, $strict=FALSE) {

		$str = strip_tags($str);

		$str = strtr (strtr($str, 
			'', 
			'SZszYAAAAAACEEEEIIIINOOOOOOUUUUYaaaaaaceeeeiiiinoooooouuuuyy'), 
				array('' => 'TH', '' => 'th', '' => 'DH', '' => 'dh', '' => 'ss', '' => 'OE', '' => 'oe', '' => 'AE', '' => 'ae', '' => 'u'));

		$str=str_replace("&amp;", "", $str);
		
		if ($strict) {
			$str=str_replace(" ", "_", $str);
			$str=strtolower(ereg_replace("[^a-zA-Z0-9_]", "", $str));
		} else {
			$str=ereg_replace("[^a-zA-Z0-9 _.,-]", "", $str);
		}
		return $str;
	} 
}



function strip_trailing_space($text) {
	global $db, $Cfg;

	$text=trim($text)."[[end]]";
	$end_p = preg_match("~</P>\[\[end\]\]$~mi", $text);
	// $text = preg_replace("~(&nbsp;|<br>|<br>|<P>|</P>|\n|\r| )*\[\[end\]\]$~mi", "\\2", $text);
	$text = preg_replace("~(&nbsp;|<br>|<br />|<P>|</P>|\n|\r| )*\[\[end\]\]$~mi", "", $text);
	if ($end_p) { $text.="</P>"; }
	
	return $text;
}


function convert_br($text) {

	debug("convert_br: ". $text);
	// first of all, convert <p> tags with an align property to a temporary tag..
	$text = preg_replace("~<p align=(.*)>(.*)</p>~mUi", "<XX align=\\1>\\2</XX>", $text);

	//convert linebreaks to <br />
	$text = nl2br($text);

	// convert <XX> back, and strip the extra <br />..
	$text = str_replace("<XX ", "<P ", $text);
	$text = str_replace("</XX>", "</P>", $text);
	$text = str_replace("</P><br />", "</P>", $text);
	$text = str_replace("<br />\n<P ", "<P ", $text);
	$text = str_replace("<br />\r\n<P ", "<P ", $text);

	return $text;

}


// Returns a string, based on whether we're generating output for
// strict XHTML or plain old HTML
function set_target($forxhtml, $forhtml) {
	global $Weblogs, $Current_weblog;

	// xhtml workaround
	if ($Weblogs[$Current_weblog]['target_blank']==2) {
		return $forxhtml;
	} else {
		// for silly people that have <base target="_blank"> set.. 
		return $forhtml;
	}

}


function convert_linebreaks($text) {

	/*
	// first of all, convert <p> tags with an align property to a temporary tag..
	$text = preg_replace("~<p align=(.*)>(.*)</p>~mUi", "<XX align=\\1>\\2</XX>", $text);

	// convert <br />'s etc to linebreaks
	$repl_from = array("\r", "\n", "<br>", "<br />", "<BR>", "<BR />", "<p>", "<P>", "</p>", "</P>");
	$repl_to = array("", "", "\n", "\n", "\n", "\n", "", "", "\n\n", "\n\n");

	$text = str_replace($repl_from, $repl_to, $text);

	// convert <XX> back, and strip the extra <br />..
	$text = str_replace("<XX ", "\n<P ", $text);
	$text = str_replace("</XX>", "</P>\n", $text);
	*/

	return strip_trailing_space(nl2br($text));

}



// adapted from an article by Allan Kent on phpbuilder.com
// this function takes the current system time and date, and offsets
// it to get the time and date we want to output to our users.
function get_current_date() {
global $Cfg;

	//debug("GCD: ".$Cfg['timeoffset_unit']." x ".$Cfg['timeoffset']);

	$date_time_array  = getdate();

	$hours =  $date_time_array["hours"];
	$minutes =  $date_time_array["minutes"];
	$seconds =  $date_time_array["seconds"];
	$month =  $date_time_array["mon"];
	$day =  $date_time_array["mday"];
	$year =  $date_time_array["year"];
	
	$timestamp =  mktime($hours ,$minutes, $seconds,$month ,$day, $year);
	
    switch ($Cfg['timeoffset_unit']) {
    
        case "y": $year +=$Cfg['timeoffset']; break;        
        case "m": $month +=$Cfg['timeoffset']; break;        
        case "d": $day+=$Cfg['timeoffset']; break;        
        case "h": $hours+=$Cfg['timeoffset']; break;        
        case "i": $minutes+=$Cfg['timeoffset']; break;        

    }    
	$timestamp =  mktime($hours ,$minutes, $seconds,$month ,$day, $year);
    return $timestamp;

}

function open_ping_window($weblogname, $filename) {
	global $Cfg, $Weblogs;

	if (isset($Cfg['ping']) && ($Cfg['ping'] == 1) ) {
		$pingurl= "includes/ping.php?title=".$weblogname."&file=".$filename;
		$rand=rand(10000,99999);
		printf("<div id='note'></div>");
		printf("<script>setTimeout(\"open_win('%s','ping_%s', 'location=no, status=yes, scrollbars=yes, resizable=yes, width=300, height=200')\",  1000);\n</script>\n", $pingurl, $rand);
	}

}



function get_entry_from_post() {
	global $Users, $Pivot_Vars, $useWysiwyg, $db;


	if ( (isset($Pivot_Vars['f_code'])) && ($Pivot_Vars['f_code']!=""))  {
		$ping=FALSE; 
		$entry = $db->read_entry($Pivot_Vars['f_code']);
	} else {
		$ping=TRUE;
		$entry['code'] = ">";
	}


	if (isset($Pivot_Vars['f_introduction_text'])) {
		$entry['introduction'] = strip_trailing_space(stripslashes($Pivot_Vars['f_introduction_text']));
		$entry['body'] = strip_trailing_space(stripslashes($Pivot_Vars['f_body_text']));

	} else {
		$entry['introduction'] = strip_trailing_space(stripslashes($Pivot_Vars['f_introduction']));
		$entry['body'] = strip_trailing_space(stripslashes($Pivot_Vars['f_body']));
	}
	
	$entry['introduction'] = tidy_html($entry['introduction'], TRUE);
	$entry['body'] = tidy_html($entry['body'], TRUE);

	$entry['category'] = @$Pivot_Vars['f_catmult'];
	$entry['date'] = fix_date($Pivot_Vars['f_createdate_1'], $Pivot_Vars['f_createdate_2']);
	$entry['publish_date'] = fix_date($Pivot_Vars['f_publishdate_1'], $Pivot_Vars['f_publishdate_2']);
	$entry['edit_date'] = fix_date($Pivot_Vars['f_editdate_1'], $Pivot_Vars['f_editdate_2']);
	$entry['title'] = strip_trailing_space(stripslashes($Pivot_Vars['f_title']));
	$entry['subtitle'] = strip_trailing_space(stripslashes($Pivot_Vars['f_subtitle']));
	$entry['user'] = $Pivot_Vars['f_user'];
	$entry['convert_lb'] = $Pivot_Vars['convert_lb'];
	$entry['status'] =  $Pivot_Vars['f_status'];
	$entry['allow_comments'] =  $Pivot_Vars['f_allowcomments'];


	return $entry;

}


// piv_error prints a fancy error message.. for dweebs that try to do
// stuff they shouldn't
function piv_error($name, $message, $endpage=0){

	echo "<h2>$name</h2>\n\n";
	echo "<div class='extrapadding2' style='width:400px;'>$message</div>";
	if($endpage==1){
		PageFooter();	
	}
	exit();
}


// attempts to fetch a webpage, and returns the <title>..
function get_webpage_title($url, $timeout, $size) {

	$url_stuff = parse_url($url);

	if ( (!isset($url_stuff['path'])) || ($url_stuff['path']=="") ) {
		$url_stuff['path'] = "/";
	}

	if ( ($url_stuff['scheme'] != "http") || ($url_stuff['host'] == "") ) {
		return "";
	} else {
		$fp = @fsockopen($url_stuff['host'], 80, $errno, $errstr, $timeout);
		if(!$fp) {
			return "";
		} else {
			fputs($fp, "GET " . $url_stuff['path'] . " HTTP/1.0\r\nHost: " .
      $url_stuff['host'] . "\r\n\r\n");
			$start = time();
			stream_set_timeout($fp, $timeout);
			$res = fread($fp, $size);
			fclose($fp);
			if ( (preg_match ("~<title>(.*)</title>~is", $res, $match)) && (strlen($match[1])>3) ) {
				
				$title=str_replace("|", "-", $match[1]);
				$title=strip_tags(str_replace("\n", "", $title));

				$number = substr($title,0,3);

				if (is_numeric($number) && ($number>=100) && ($number<=600)) {
					return "";
				} else {	
					return $title;
				}
			}
		}
		return "";
	}
}



// returns the browser, extracted from the $agent string..
function getbrowser($agent) {


	if (file_exists('includes/phpsniff/phpSniff.class.php')) {
			include_once('includes/phpsniff/phpSniff.class.php');
	} else {
		include_once('includes/phpsniff/phpsniff.class.php');
	}

	$client = new phpSniff($agent,0);
	$client->init();

	if ($client->property('long_name')!="") {
		return ucfirst($client->property('long_name'))." ".$client->property('version')." (".$client->property('platform').")";
	} else {
		return trimtext($agent,20);
	}

}

// convert relative URL's to absolute URL's
function RelativeToAbsoluteURLS($data) {

	global $HTTP_SERVER_VARS;

	$host = "http://".$HTTP_SERVER_VARS['HTTP_HOST'];

	$data = preg_replace("/a href=(['\"])(?!http)/mUi", "a href=\\1$host\\2", $data);
	$data = preg_replace("/img src=(['\"])(?!http)/mUi", "img src=\\1$host\\2", $data);
	
	//$data = preg_replace("/a/mUi", "EE", $data);

	return ($data);
}


function add_log($msg) {
	global $Cfg, $Pivot_Vars;

	if ($Pivot_Vars['user']=="") {
		$user= "(visitor)";
	} else {
		$user= $Pivot_Vars['user'];
	}


	if (isset($Cfg['log'])  && ($Cfg['log']==1) ) {
		$filename = "log_".date("Ymd").".txt";
		$date = date("[ Ymd - H:i:s (". timetaken('int') .") ] ");
		$msg = $date . $Pivot_Vars['REMOTE_ADDR'] ." - ". $Pivot_Vars['user'] ." - ". $msg;

		if ($fp=@fopen("db/$filename", "a")) {
			fwrite($fp, $msg."\n");
			fclose ($fp);
		}

	}

}



?>
